(* Successively generate the permutations of 1 through n using an
   interruptible, nonrecursive version of Program 2.5. *)
var SwapWithWhom: array [1..n] of integer;
      (* Static variable for function Next.  SwapWithWhom[i] is the position
         to the right of i with which A[i] will be swapped to form
         the next subset of permutations.  SwapWithWhom holds the state
         of the process in the nonrecursive version of the function.
         SwapWithWhom[i] = n+1 means that all swaps have been completed.
         Initialize SwapWithWhom (for i := 1 to n do SwapWithWhom[i] := i + 1)
         before the first call to the function Next. *)
function Next(var A: board): boolean;
  (* Given a board position A with all queens in distinct rows and
     columns, return the next board position with the same property.
     A should not be changed by the caller between calls and must
     be initialized by the caller to the first such placement, A[i] := i.
     If no further placement exists, then Next returns false. *)
  label 1;
  var i, t, stacktop: integer;
  begin
    stacktop := n - 1;
    while stacktop > 0 do
      if SwapWithWhom[stacktop] = n + 1
        then begin
               (* Do the circular shift left... *)
               t := A[stacktop];
               for i := stacktop+1 to n do A[i-1] := A[i];
               A[n] := t;
               (* ...and next time start swapping process over. *)
               SwapWithWhom[stacktop] := stacktop + 1;
               stacktop := stacktop - 1
             end
        else begin
               (* Do the SWAP... *)
               t := A[stacktop];
               A[stacktop] := A[SwapWithWhom[stacktop]];
               A[SwapWithWhom[stacktop]] := t;
               (* ...and next time SWAP with the next element. *)
               SwapWithWhom[stacktop] := SwapWithWhom[stacktop] + 1;
               Next := true;
               goto 1 (* return *)
             end;
    Next := false;
1:
  end; (* Next *)
