const n = ...;
type board = array [1..n] of 1..n;
function Next(var A: board): boolean;
  (* Given a board position A with all queens in distinct rows and
     columns, return the next board position with the same property.
     A should not be changed by the caller between calls and must be
     initialized by the caller to the first such placement, A[i] := i.
     If no further placement exists, then Next returns false. *)
  label 1;
  var inuse: array [1..n] of boolean;
        (* records rows that are currently occupied *)
      i, j, k, m: integer;
  begin
    (* Since there is only one possible place for queen n,
       queen n-1 will need to be repositioned as well. *)
    for i := 1 to n-2 do inuse[A[i]] := true;
    inuse[A[n]] := false;
    i := n - 1; (* Attempt to push queen i forward. *)
    repeat
      inuse[A[i]] := false;
      for j := A[i]+1 to n do
        (* Look for an unoccupied row farther along. *)
        if not inuse[j]
          then begin
                 A[i] := j;
                 inuse[j] := true;
                 for k := i+1 to n do
                   (* Place the next queen on as low a row as possible. *)
                   begin
                     m := 1;
                     while inuse[m] do m := m + 1; (* cannot push m to n+1 *)
                     A[k] := m;
                     inuse[m] := true (* row now in use *)
                   end;
                 Next := true;
                 goto 1 (* return *)
               end;
      (* No way to push queen i onward. *)
      i := i - 1
    until i = 0; (* Last placement was in A. *)
    Next := false;
1:
  end; (* Next *)
